# Changelog

## 4.7.0 (2022-11-18)

### Features

- **Angular v15 support**
- Add `countUp` directive
- Add `autofocus` directive
- Add `timespan` directive
- Add `StringHelper.toChunks()`
- Make `isMobile` Observable friendly

### Bugfixes

- Enforece naming conventions

## 4.6.0 (2022-09-27)

### Bugfixes

- LoggingInterceptor: do not log empty body

### Features

- Add time-span and string implode / implodeMapped pipe
- Update string imploder
- **BREAKING** Update abstract title strategy
- Add online offline and ping directive
- Require @angular/cdk package
- Logging enhancements

## 4.5.5 (2022-09-05)

### Bug Fixes

- **helper:** logging interceptor returns text and not error ([a6d0bd5](https://gitlab.com/DatePoll/common/dfx-common/-/commit/a6d0bd58f3a998bcccc81f0ae92d5a8fff155d63))
- version ([5eb386f](https://gitlab.com/DatePoll/common/dfx-common/-/commit/5eb386fb1beed7afbd659b33a03ad1ce13b6c485))

## 4.5.3 (2022-08-16)

### Features

- **helper:** add abstract title and DfxPreload Strategy ([4bdf7f0](https://gitlab.com/DatePoll/common/dfx-common/-/commit/4bdf7f076f7482e8fff4a9f97f7d8ab2c9399914))
- **helper:** add btn spinner and transform css classes ([13071f6](https://gitlab.com/DatePoll/common/dfx-common/-/commit/13071f685057881a1ddc0ff6300437549a99dcba))
- **helper:** add pluck to list ([38d09f5](https://gitlab.com/DatePoll/common/dfx-common/-/commit/38d09f5901fb0d738a50fb2514835fa57c9b0884))

### Bug Fixes

- **helper:** pluck and tests ([f32c873](https://gitlab.com/DatePoll/common/dfx-common/-/commit/f32c8730c9b1e74bc679fd3c41826d10aa508179))
- version ([5eb386f](https://gitlab.com/DatePoll/common/dfx-common/-/commit/5eb386fb1beed7afbd659b33a03ad1ce13b6c485))

## 4.5.2 (2022-07-27)

### Features

- **helper:** add unsubscribeAll() to abstract component ([61c255a](https://gitlab.com/DatePoll/common/dfx-common/-/commit/61c255a6cc974c10e07212d1c9835bab2bfa03b0))
- **helper:** enhance http interceptor logging ([fa0d0e3](https://gitlab.com/DatePoll/common/dfx-common/-/commit/fa0d0e324c874f574a97a366acca74ed88a1e2c3))

### Bug Fixes

- **helper:** do not send refresh selected entity with subject ([b06d6c9](https://gitlab.com/DatePoll/common/dfx-common/-/commit/b06d6c91349cea67684d4db23fc76117fa60ba91))
- **helper:** log unaligned bug ([16a50c2](https://gitlab.com/DatePoll/common/dfx-common/-/commit/16a50c2b5ccdd573b81238845e9923483efa5074))
- version ([5eb386f](https://gitlab.com/DatePoll/common/dfx-common/-/commit/5eb386fb1beed7afbd659b33a03ad1ce13b6c485))

## 4.5.1 (2022-07-19)

### Bug Fixes

- **helper:** list initialization broken ([753180e](https://gitlab.com/DatePoll/common/dfx-common/-/commit/753180e03861b5446962d879bcca4cc94f2941b4))
- **helper:** remember results ([b49a569](https://gitlab.com/DatePoll/common/dfx-common/-/commit/b49a569265401e6b2371e7e5a45261174325e201))
- version ([5eb386f](https://gitlab.com/DatePoll/common/dfx-common/-/commit/5eb386fb1beed7afbd659b33a03ad1ce13b6c485))

## 4.5.0 (2022-07-18)

### Features

- **general:** add README.md export to project assets ([7efc4e9](https://gitlab.com/DatePoll/common/dfx-common/-/commit/7efc4e9ff309fff90d4c5cae3a01015060fa2cf6))
- **general:** make tsconfig better ([612efca](https://gitlab.com/DatePoll/common/dfx-common/-/commit/612efca3d17d95e28c023012549f0540a3f37510))
- **helper:** add abstract ignoreable interceptor ([aa7c35f](https://gitlab.com/DatePoll/common/dfx-common/-/commit/aa7c35f2239b500793a0c53ded5666788fe3f888))
- **helper:** add better way to disable interceptors on request basis ([0237ad8](https://gitlab.com/DatePoll/common/dfx-common/-/commit/0237ad854b2cc8c84a6a6c23b701f446a81b918a))
- **helper:** add Entity implementations ([628b658](https://gitlab.com/DatePoll/common/dfx-common/-/commit/628b65820df46e7272a9803c08c820b683b5c72a))
- **helper:** add float generator, rename generation methods ([0be9e8e](https://gitlab.com/DatePoll/common/dfx-common/-/commit/0be9e8e188e3279551dfd858f32cee6d965872dd))
- **helper:** add GenericHelper and GenericImplTrait ([9dc439a](https://gitlab.com/DatePoll/common/dfx-common/-/commit/9dc439ad82cdcf8acdf2ae1922bc3498d7f2b935))
- **helper:** add GenericImplTrait to Lists ([8bbbf55](https://gitlab.com/DatePoll/common/dfx-common/-/commit/8bbbf5502107bfa657fb6745ea01956866ce11e2))
- **helper:** add generics to abstract http service ([1fcdd7f](https://gitlab.com/DatePoll/common/dfx-common/-/commit/1fcdd7fbaec2f11899145fdb1d09711625b4cf73))
- **helper:** add getAll url key pairs ([307b2b8](https://gitlab.com/DatePoll/common/dfx-common/-/commit/307b2b86d0f92cae2b0382f987b811800142aaf3))
- **helper:** add global parseKeyValuePairs and use it in AEntityService ([e0fb0d3](https://gitlab.com/DatePoll/common/dfx-common/-/commit/e0fb0d35025f447335c8471f4a5df12e2576adf4))
- **helper:** add ignore paths to base url interceptor ([294e37f](https://gitlab.com/DatePoll/common/dfx-common/-/commit/294e37f29a8e1abb00012ab9065c4b43bc2d5f80))
- **helper:** add listOf function for easy list creation ([8a94f2d](https://gitlab.com/DatePoll/common/dfx-common/-/commit/8a94f2ddab4195dffe06b3074b0434952f1da319))
- **helper:** add map and mapIf to list ([3750637](https://gitlab.com/DatePoll/common/dfx-common/-/commit/37506377f26ee6b07e241c0c4e15e21a7574a43e))
- **helper:** add missing changelog entries ([6e44984](https://gitlab.com/DatePoll/common/dfx-common/-/commit/6e44984578f8b96c0daa170c311b1f49ab894410))
- **helper:** add null to undefined converter ([fc46aa1](https://gitlab.com/DatePoll/common/dfx-common/-/commit/fc46aa1ae9fc49be7c75ebe1816434381d1ae17b))
- **helper:** add once and throttle decorator, update remember result ([3a11b17](https://gitlab.com/DatePoll/common/dfx-common/-/commit/3a11b1795a8b09ddc338d572b16d625eab444756))
- **helper:** add option do enable legacy copying ([8dac53b](https://gitlab.com/DatePoll/common/dfx-common/-/commit/8dac53b0c01ef992d65e885e7a53f01252c5236b))
- **helper:** add print directive ([162889e](https://gitlab.com/DatePoll/common/dfx-common/-/commit/162889eb3284561cda4f521f8c6b924213122f1d))
- **helper:** add storage service ([3736219](https://gitlab.com/DatePoll/common/dfx-common/-/commit/3736219e5e6ffefdb9aa8380bdfc2a427c4cfcb0))
- **helper:** add StorageHelper.isFull() ([c59a9d8](https://gitlab.com/DatePoll/common/dfx-common/-/commit/c59a9d8f4fbc025cff31cc362415449b8d39f68f))
- **helper:** add StorageHelper.isNotFull() ([55ddc12](https://gitlab.com/DatePoll/common/dfx-common/-/commit/55ddc128198e159309bb7ae52a80bc72b913b68a))
- **helper:** add time to live for StorageHelper ([430b431](https://gitlab.com/DatePoll/common/dfx-common/-/commit/430b431dd718159b65a6515718a604e503c010d1))
- **helper:** add toggle in constructor to directly activate stopwatch ([2c3d35f](https://gitlab.com/DatePoll/common/dfx-common/-/commit/2c3d35f736fd6597064b488e5a072f730e2796ea))
- **helper:** add track by directive ([9749d8c](https://gitlab.com/DatePoll/common/dfx-common/-/commit/9749d8c18e45078568fb3cc9d743f0c47b64cf37))
- **helper:** add undefined to null converter ([1931c88](https://gitlab.com/DatePoll/common/dfx-common/-/commit/1931c88f0d3a818c1d99e3b11404f7e0e2b23100))
- **helper:** add url key pairs to all httpentity methods ([8557485](https://gitlab.com/DatePoll/common/dfx-common/-/commit/85574857666684a139b5ef4859eb9c82fe9c62da))
- **helper:** allow DateHelper to parse dates in strings ([72a56ad](https://gitlab.com/DatePoll/common/dfx-common/-/commit/72a56adacf2238a356ec222503c7e3a56f9af0cb))
- **helper:** change abstract-entity service params to key value pair ([df8dc79](https://gitlab.com/DatePoll/common/dfx-common/-/commit/df8dc794850dedc2ab7b06d69114b293a4c6cc89))
- **helper:** enhance stopwatch ([fa0545c](https://gitlab.com/DatePoll/common/dfx-common/-/commit/fa0545c05eb2f1789dc20b4535acbe4f980c0fe7))
- **helper:** log header and object in same line ([b9076b3](https://gitlab.com/DatePoll/common/dfx-common/-/commit/b9076b306810cb114bae2e64902908b303c4d271))
- **helper:** log params in AbstractHttpService ([a0715f5](https://gitlab.com/DatePoll/common/dfx-common/-/commit/a0715f5f00a2b170736306c9e9406a7e3c26428b))
- **helper:** make is-mobile-service break point customizable ([956a84a](https://gitlab.com/DatePoll/common/dfx-common/-/commit/956a84a042383fef02ed1e3b38bd683ee526bfb4))
- **helper:** make LoggerFactory a service ([5ad21de](https://gitlab.com/DatePoll/common/dfx-common/-/commit/5ad21de22725732fe9b0f187d1a2847f413f9571))
- **helper:** make StorageHelper set() object compatible ([153bb09](https://gitlab.com/DatePoll/common/dfx-common/-/commit/153bb09bc19ef10a90cc0aa36318da23736f3626))
- **helper:** migrate dfx-helper.scss to helper.scss, add color.scss ([67c06c4](https://gitlab.com/DatePoll/common/dfx-common/-/commit/67c06c4b3401de1ecdf086b531e3bec5db4ee296))
- **helper:** move KeyValuePair into own class ([77701b3](https://gitlab.com/DatePoll/common/dfx-common/-/commit/77701b374507361ffb3e1133a690af8f7e58ef95))
- **helper:** refactor lists ([2d00318](https://gitlab.com/DatePoll/common/dfx-common/-/commit/2d00318d46684c7dc42f866a2ea95759cba6c051))
- **helper:** remove abstract entity with name interface ([412e8b2](https://gitlab.com/DatePoll/common/dfx-common/-/commit/412e8b2096325b3c98d5e5eb6f3858bb04b031fa))
- **helper:** remove abstract http service ([aa425ad](https://gitlab.com/DatePoll/common/dfx-common/-/commit/aa425ad78c563f874fbf5f6d612dfaf99a62ffb3))
- **helper:** return string on clipboard read, add new method for copying ([213bee0](https://gitlab.com/DatePoll/common/dfx-common/-/commit/213bee0a8afc5823a42be0effffb103aaa366e56))
- **helper:** run tests in headless chrome mode ([b4f2a63](https://gitlab.com/DatePoll/common/dfx-common/-/commit/b4f2a63099780907395fa76ee35ff7d34c7c112b))
- **helper:** storage-helper add fillUp ([39a8b8b](https://gitlab.com/DatePoll/common/dfx-common/-/commit/39a8b8bfe0bb27433f8f645427777e3f14605dc5))
- **helper:** type enhancements ([da68e57](https://gitlab.com/DatePoll/common/dfx-common/-/commit/da68e57f00ab8521cdd771f800ca234cd1436995))
- **helper:** update changelog and include it in bundle ([abeff18](https://gitlab.com/DatePoll/common/dfx-common/-/commit/abeff18fcdf614591e84001392c113577d33a944))

### Bug Fixes

- **general:** update git links to new common project ([ab8394d](https://gitlab.com/DatePoll/common/dfx-common/-/commit/ab8394df524fa3713d064ed394c6ac698a02de7a))
- **helper:** add Confirmable decorator to public api ([cf27d9a](https://gitlab.com/DatePoll/common/dfx-common/-/commit/cf27d9adf626196ac4175f01af6aa56b232eb471))
- **helper:** add DfxHelperModule to public api ([2e3b20d](https://gitlab.com/DatePoll/common/dfx-common/-/commit/2e3b20d81df09e06d0bf8f8ba60b1090c9f68c41))
- **helper:** allow converter toType methods to convert itself ([f76501d](https://gitlab.com/DatePoll/common/dfx-common/-/commit/f76501db9500e63e680bbd083533f158d3cb9a9a))
- **helper:** array bug ([f89416a](https://gitlab.com/DatePoll/common/dfx-common/-/commit/f89416ae6a03011ac53c6c21d2c241c57827d4fa))
- **helper:** dfx print test ([183f00d](https://gitlab.com/DatePoll/common/dfx-common/-/commit/183f00de4c287310810dccfe4bb9ab4c104be405))
- **helper:** export new interceptors ([439bfb8](https://gitlab.com/DatePoll/common/dfx-common/-/commit/439bfb823e7e4a7a6f348ee270310e2a4d969473))
- **helper:** fix converter js doc ([ca8aa3b](https://gitlab.com/DatePoll/common/dfx-common/-/commit/ca8aa3bd0383fd8fa468aebf2b7947204c09bb38))
- **helper:** fix converter number to boolean conversion error ([8868162](https://gitlab.com/DatePoll/common/dfx-common/-/commit/88681627ebe96af3ef27aed475b1395bcfe3237d))
- **helper:** fix entity service bug ([73ecbee](https://gitlab.com/DatePoll/common/dfx-common/-/commit/73ecbee05bd7c90237493903d4ff0a7c196ee834))
- **helper:** parseKeyPairsToHttpParams and add unit tests ([86b9f01](https://gitlab.com/DatePoll/common/dfx-common/-/commit/86b9f01a04ec4b0c68365a5092e85a969646f2a4))
- **helper:** refresh selected entity if fetchAll is executed ([370165b](https://gitlab.com/DatePoll/common/dfx-common/-/commit/370165bc1f5cf03fd7b2e30388e814dcdb8dbd87))
- **helper:** remember results ([b49a569](https://gitlab.com/DatePoll/common/dfx-common/-/commit/b49a569265401e6b2371e7e5a45261174325e201))
- **helper:** remove one / to much ([56dbe14](https://gitlab.com/DatePoll/common/dfx-common/-/commit/56dbe14a56be26820a1c26c0f7b59efeaaecdd0f))
- **helper:** remove return on dfx print setter ([aa4487e](https://gitlab.com/DatePoll/common/dfx-common/-/commit/aa4487e4d8ecf430f96b4132d2a386ffa35091ca))
- **helper:** return null if null is passed to date formatter ([9122195](https://gitlab.com/DatePoll/common/dfx-common/-/commit/9122195dd4fea8c841a051ac00b6213df0052468))
- **helper:** storage helper api ([2ee93ae](https://gitlab.com/DatePoll/common/dfx-common/-/commit/2ee93aefa3fec5301fa1f74bd378dbe1c94db181))
- **helper:** type issues ([4962159](https://gitlab.com/DatePoll/common/dfx-common/-/commit/4962159ade7839f27fd5fb40d450e67d29620203))
- **helper:** typo in Generator ([94779ee](https://gitlab.com/DatePoll/common/dfx-common/-/commit/94779eef46ba4abcd00cd2d6fea040c992978219))
- **heper:** dfx print ([bb95000](https://gitlab.com/DatePoll/common/dfx-common/-/commit/bb95000ef2291e06b998e6ff45b8fa6929d8e957))
- version ([5eb386f](https://gitlab.com/DatePoll/common/dfx-common/-/commit/5eb386fb1beed7afbd659b33a03ad1ce13b6c485))

## v4.4.0

### New

- **Angular v14** support

## v4.3.1

### New

- Add `null` to `undefined` converter
- Add `undefined` to `null` converter

### Fixes

- Refresh selected entity if `fetchAll` is called

## v4.3.0

### New

- Add `Entity` implementations
- Add `Generics` to `AbstractHttpService`
- Add `GenericHelper`
- Refactor `Lists` to support `Generics` better
- Add `float` random generator
- Enhance `StopWatch` with `stopAndGetTimeInX`, `createStarted()`, `createStopped`, `hasStarted`, `isRunning`,
  `isStopped`

### Changes

- Unify helper class naming
- Add options do enable legacy copying
- Doc updates

### Fixes

- Return `undefined` if `undefined` is passed to `DateHelper`
- Fix number to boolean `Converter` issue

## v4.2.2

### Fixes

- Add `DfxHelperModule` to public api

## v4.2.1

### Fixes

- `StorageHelper` api incompatibilities

## v4.2.0

### New

- `DateHelper` is now able to parse `strings`
- Make `IsMobileService` breakpoint customizable
- Split `dfx-helper.scss` into `helper.scss` and `colors.scss`
- Type enhancements
- Make default `StorageHelper.set()` method object compatible
- Add TTL to `StorageHelper`

### Changes

- Return a promise with a `string` from `ClipboardHelper.read()`
- Use new method for copying stuff to your clipboard
- Refactored `Lists`

## v4.1.0 - v4.1.2

### Changes

- `KeyValuePair` updates

## v4.0.12

### Changes

- Move `KeyValuePair` into own class

### Fixes

- Add `Confirmable` decorator to public api
- Generator typos

## v4.0.9 - v4.0.11

### Fixes

- `EntityService` bug

## v4.0.8

### New

- Add `KeyPairs` to all http service methods

## v4.0.7

### New

- Add `getAll()` to `KeyPairs`
- Add `listOf()` functions for easy list creation

### Changes

- Allow `Converter` methods to convert themselves

## v4.0.6

### Fixes

- Fixes error handling in `HttpService`

## v4.0.5

### Fixes

- Fixes indexOf not checking entity ids for `EntityList`

## v4.0.4

### Fixes

- Return `EntityList` on clone function from `EntityList`

## v4.0.3

### Fixes

- Log bug where empty http responses where marked as error

## v4.0.2

### New

- Add `Confirmable(question: string)` annotation / decorator
- Add `params` parameter in `AHttpService` and `AEntityService` request methods

### Changes

- rxjs7 method parameter signature migrations
- Documentation updates for `RememberResults`, `Stopwatch` and `Thread`

### Fixes

- Do not log responses with an empty body as error

## v4.0.1

### Changes

- **Angular v13 support**

### Fixes

- Make `version` property in `AHttpService` optional

## v4.0.0

### Breaking

- **Shorten all class names starting with `Abstract` to `A`**

  - Affected classes:
    - `AbstractComponent` -> `AComponent`
    - `AbstractEntity` -> `AEntity`
    - `AbstractEntityWithName` -> `AEntityWithName`
    - `AbstractEntityService` -> `AEntityService`
    - `AbstractSelectableEntityService` -> `ASelectableEntityService`
    - `AbstractHttpService` -> `AHttpService`

- Change list return types to always return current list, making them **chainable**
  - Remove `getShuffeld()`, add `shuffle()`
  - Affected methods:
    - `addIf()`, `addIfAbsent()`
    - `remove()`
    - `removeIf()`, `removeIfPresent()`
    - `foreachIf()`
    - `computeIf()`, `computeIfAbsent()`, `computeIfPresent()`

### New

- Add **Decorators**/**Annotations**
  - `MeasureTime()`
  - `RememberResult`
  - `RunOutsideChangeDetection`
  - `Delay()`
- Add `Thread` helper
- Add `isString()` and `isNumber()` in `TypeHelper`
- Add `isArray()` and `isIterable()` in `ArrayHelper`
- Add `toString()`, `toBoolean()` and `toNumber()` methods to `Converter`
- Deprecate other type specific methods of `Converter`; **won't probably be removed**

### Change

- Use `IEntity` instead of `AEntity` in `AEntityService` and `EntityList`
- Use `Array<T>` instead of `IList<T>` as parameter of `setAll()` method in `AEntityService`
- Return `Observable<unknown>` instead of `any` in `AHttpService` and `AEntityService`

### Fixes

- Reset `laps` if `reset()` method is called in `Stopwatch`
